Bon, vous savez qu'une base de données sert à gérer les données. Très bien. Mais comment ?? Facile ! Comment organisez-vous vos données dans la "vie réelle" ?? Vos papiers par exemple ? Chacun son organisation bien sûr, mais je suppose que vous les classez d'une manière ou d'une autre.

Toutes les factures ensemble, tous les contrats ensemble, etc. Ensuite on subdivise : les factures d’électricité, les factures pour la voiture. Ou bien dans l'autre sens : tous les papiers concernant la voiture ensemble, puis subdivision en taxes, communication avec l'assureur, avec le garagiste, ...

Une base de données, c'est pareil ! On classe les informations. MySQL étant un SGBDR, je ne parlerai que de l'organisation des bases de données relationnelles. 

Comme je vous l'ai dit précédemment, on représente les données sous forme de **tables**. Une base va donc contenir plusieurs tables (elle peut n'en contenir qu'une bien sûr, mais c'est rarement le cas). Si je reprends mon exemple précédent, on a donc une table représentant des clients (donc des personnes).

Chaque table définit un certain nombre de **colonnes**, qui sont les caractéristiques de l'objet représenté par la table (les attributs de l'en-tête dans la théorie relationnelle). On a donc ici une colonne "Nom", une colonne "Prénom", une colonne "Email" et une colonne "Numéro" qui nous permettent d'identifier les clients individuellement (les noms et prénoms ne suffisent pas toujours).




+------+-------+--------+-------------------------+
|Numéro|Nom    |Prénom  |Email                    |
+======+=======+========+=========================+
|1     |Jean   |Dupont  |jdupont@email.com        |
+------+-------+--------+-------------------------+
|2     |Marie  |Malherbe|mama@email.com           |
+------+-------+--------+-------------------------+
|3     |Nicolas|Jacques |jacques.nicolas@email.com|
+------+-------+--------+-------------------------+
|4     |Hadrien|Piroux  |happi@email.com          |
+------+-------+--------+-------------------------+




Si je récapitule, dans une base nous avons donc des **tables**, et dans ces **tables**, on a des **colonnes**. Dans ces tables, vous introduisez vos données. Chaque donnée introduite le sera sous forme de **ligne** dans une **table**, définissant la valeur de chaque **colonne** pour cette donnée.

*[SGBDR]: Système de Gestion de Bases de Données Relationnelles