Pour télécharger MySQL, vous pouvez vous rendre sur le site suivant :

[http://dev.mysql.com/downloads/mysql/#downloads](http://dev.mysql.com/downloads/mysql/#downloads)

Sélectionnez l'OS sur lequel vous travaillez (Windows, Mac OS ou Linux).


# Windows

Téléchargez MySQL avec l'installeur (MSI Installer), puis exécutez le fichier téléchargé. L'installeur démarre et vous guide lors de l'installation.
Lorsqu'il vous demande de choisir entre trois types d'installation, choisissez "Typical". Cela installera tout ce dont nous pourrions avoir besoin.

![Choix du type d'installation](/media/galleries/1255/a19d0cbf-ec78-48e6-8551-1091aa7b1548.png)

L'installation se lance. Une fois qu'elle est terminée, cliquez sur "Terminer" **après vous être assurés** que la case "lancer l'outil de configuration MySQL" est cochée.

![Lancement outil de configuration](/media/galleries/1255/df840d49-b52a-4119-8b68-bc06f5d617f6.png)

Dans cet outil de configuration, choisissez la configuration standard, et à l'étape suivante, cochez l'option "Include Bin Directory in Windows PATH"

![Options configurations](/media/galleries/1255/cb541c27-0992-4a83-ad66-7728e488f2fc.png)

On vous propose alors de définir un nouveau mot de passe pour l'utilisateur "root". Choisissez un mot de passe et confirmez-le. Ne cochez aucune autre option à cette étape. Cliquez ensuite sur "Execute" pour lancer la configuration.


# Mac OS

Téléchargez l'archive DMG qui vous convient (32 ou 64 bits), double-cliquez ensuite sur ce .dmg pour ouvrir l'image disque.
Vous devriez y trouver 4 fichiers dont deux .pkg. Celui qui nous intéresse s'appelle mysql-5.5.9-osx10.6-x86_64.pkg (les chiffres peuvent changer selon la version de MySQL téléchargée et votre ordinateur). Ouvrez ce fichier qui est en fait l'installateur de MySQL, et suivez les instructions.

Une fois le programme installé, vous pouvez ouvrir votre terminal (pour rappel, il se trouve dans Applications -> Utilitaires).

Tapez les commandes et exécutez les instructions suivantes :


```console
cd /usr/local/mysql
sudo ./bin/mysqld_safe
```



- Entrez votre mot de passe si nécessaire
- Tapez ||Ctrl|| + ||Z||



```console
bg
```



- Tapez ||Ctrl|| + ||D||
- Quittez le terminal


MySQL est prêt à être utilisé !


## Configuration

Par défaut, aucun mot de passe n'est demandé pour se connecter, même avec l'utilisateur root (qui a tous les droits). Je vous propose donc de définir un mot de passe pour cet utilisateur :


```console
/usr/local/mysql/bin/mysqladmin -u root password <votre_mot_de_passe>
```

Ensuite, pour pouvoir accéder directement au logiciel client depuis la console, sans devoir aller dans le dossier où est installé le client, il vous faut ajouter ce dossier à votre variable d'environnement PATH. Pour cela, tapez la commande suivante dans le terminal :


```console
echo 'export PATH=/usr/local/mysql/bin:$PATH' >> ~/.profile
```

`/usr/local/mysql/bin` est donc le dossier dans lequel se trouve le logiciel client (plusieurs logiciels clients en fait). Redémarrez votre terminal pour que le changement prenne effet.


# Linux


## Sous Debian ou Ubuntu

Exécuter la commande suivante pour installer MySQL :


```console
sudo apt-get install mysql-server mysql-client
```

Une fois votre mot de passe introduit, MySQL va être installé.


## Sous RedHat

Exécuter la commande suivante pour installer MySQL :


```console
sudo yum install mysql mysql-server
```

Une fois votre mot de passe introduit, MySQL va être installé.


## Dans tous les cas, après installation

Pensez ensuite à modifier le mot de passe de l'utilisateur _root_ (administrateur ayant tous les droits) avec la commande suivante :


```console
sudo mysqladmin -u root -h localhost password '<votre mot de passe>'
```