# Ajout
 
On utilise la syntaxe suivante :


```sql
ALTER TABLE nom_table 
ADD [COLUMN] nom_colonne description_colonne;
```

Le `[COLUMN]` est facultatif, donc si à la suite de `ADD` vous ne précisez pas ce que vous voulez ajouter, MySQL considérera qu'il s'agit d'une colonne.
`description_colonne` correspond à la même chose que lorsque l'on crée une table. Il contient le type de donnée et éventuellement `NULL` ou `NOT NULL`, etc.

Ajoutons une colonne _date_insertion_ à notre table de test. Il s'agit d'une date, donc une colonne de type `DATE` convient parfaitement. Disons que cette colonne ne peut pas être `NULL` (si c'est dans la table, ça a forcément été inséré). Cela nous donne :


```sql
ALTER TABLE Test_tuto 
ADD COLUMN date_insertion DATE NOT NULL;
```

Un petit `DESCRIBE Test_tuto;` vous permettra de vérifier les changements apportés.


# Suppression

La syntaxe de `ALTER TABLE ... DROP ...` est très simple :

```sql
ALTER TABLE nom_table 
DROP [COLUMN] nom_colonne;
```

Comme pour les ajouts, le mot `COLUMN` est facultatif. Par défaut, MySQL considérera que vous parlez d'une colonne.

**Exemple** : nous allons supprimer la colonne _date_insertion_, que nous remercions pour son passage éclair dans le cours.


```sql
ALTER TABLE Test_tuto 
DROP COLUMN date_insertion; -- Suppression de la colonne date_insertion
```