# Changement du nom de la colonne

Vous pouvez utiliser la commande suivante pour changer le nom d'une colonne :


```sql
ALTER TABLE nom_table 
CHANGE ancien_nom nouveau_nom description_colonne;
```

Par exemple, pour renommer la colonne _nom_ en _prenom_, vous pouvez écrire


```sql
ALTER TABLE Test_tuto 
CHANGE nom prenom VARCHAR(10) NOT NULL;
```

Attention, la description de la colonne doit être complète, sinon elle sera également modifiée. Si vous ne précisez pas `NOT NULL` dans la commande précédente, _prenom_ pourra contenir `NULL`, alors que du temps où elle s'appelait _nom_, cela lui était interdit.


# Changement du type de données

Les mots-clés `CHANGE` et `MODIFY` peuvent être utilisés pour changer le type de donnée de la colonne, mais aussi changer la valeur par défaut ou ajouter/supprimer une propriété `AUTO_INCREMENT`. Si vous utilisez `CHANGE`, vous pouvez, comme on vient de le voir, renommer la colonne en même temps. Si vous ne désirez pas la renommer, il suffit d'indiquer deux fois le même nom.
Voici les syntaxes possibles :


```sql
ALTER TABLE nom_table 
CHANGE ancien_nom nouveau_nom nouvelle_description;

ALTER TABLE nom_table 
MODIFY nom_colonne nouvelle_description;
```

Des exemples pour illustrer :


```sql
ALTER TABLE Test_tuto 
CHANGE prenom nom VARCHAR(30) NOT NULL; -- Changement du type + changement du nom

ALTER TABLE Test_tuto 
CHANGE id id BIGINT NOT NULL; -- Changement du type sans renommer

ALTER TABLE Test_tuto
MODIFY id BIGINT NOT NULL AUTO_INCREMENT; -- Ajout de l'auto-incrémentation

ALTER TABLE Test_tuto 
MODIFY nom VARCHAR(30) NOT NULL DEFAULT 'Blabla'; -- Changement de la description (même type mais ajout d'une valeur par défaut)
```

Il existe pas mal d'autres possibilités et combinaisons pour la commande `ALTER TABLE` mais en faire la liste complète ne rentre pas dans le cadre de ce cours. Si vous ne trouvez pas votre bonheur ici, je vous conseille de le chercher dans la [documentation officielle](http://dev.mysql.com/doc/refman/5.5/en/alter-table.html).