La requête qui permet de sélectionner et afficher des données s'appelle `SELECT`. Nous l'avons déjà un peu utilisée dans le chapitre d'installation, ainsi que pour afficher tout le contenu de la table _Animal_.

`SELECT` permet donc d'afficher des données directement. Des chaînes de caractères, des résultats de calculs, etc.

**Exemple**

```sql
SELECT 'Hello World !';
SELECT 3+2;
```

`SELECT` permet également de sélectionner des données à partir d'une table. Pour cela, il faut ajouter une clause à la commande `SELECT` : la clause `FROM`, qui définit de quelle structure (dans notre cas, une table) viennent les données.


```sql
SELECT colonne1, colonne2, ... 
FROM nom_table;
```

Par exemple, si l'on veut sélectionner l'espèce, le nom et le sexe des animaux présents dans la table _Animal_, on utilisera :


```sql
SELECT espece, nom, sexe 
FROM Animal;
```


# Sélectionner toutes les colonnes

Si vous désirez sélectionner toutes les colonnes, vous pouvez utiliser le caractère * dans votre requête :


```sql
SELECT * 
FROM Animal;
```

Il est cependant déconseillé d'utiliser `SELECT *` trop souvent. Donner explicitement le nom des colonnes dont vous avez besoin présente deux avantages :


- d'une part, vous êtes certains de ce que vous récupérez ;
- d'autre part, vous récupérez uniquement ce dont vous avez vraiment besoin, ce qui permet d'économiser des ressources.


Le désavantage est bien sûr que vous avez plus à écrire, mais le jeu en vaut la chandelle.

Comme vous avez pu le constater, les requêtes `SELECT` faites jusqu'à présent sélectionnent toutes les lignes de la table. Or, bien souvent, on ne veut qu'une partie des données. Dans la suite de ce chapitre, nous allons voir ce que nous pouvons ajouter à cette requête `SELECT` pour faire des sélections à l'aide de critères.