Le dernier opérateur à utiliser dans la clause `WHERE` que nous verrons dans ce chapitre est `IN`. Ce petit mot de deux lettres, bien souvent méconnu des débutants, va probablement vous permettre d'économiser du temps et des lignes.

Imaginons que vous vouliez récupérer les informations des animaux répondant aux doux noms de Moka, Bilba, Tortilla, Balou, Dana, Redbul et Gingko. Jusqu'à maintenant, vous auriez sans doute fait quelque chose comme ça :


```sql
SELECT * 
FROM Animal 
WHERE nom = 'Moka' 
    OR nom = 'Bilba' 
    OR nom = 'Tortilla' 
    OR nom = 'Balou' 
    OR nom = 'Dana' 
    OR nom = 'Redbul' 
    OR nom = 'Gingko';
```

Un peu fastidieux non  :( ? Eh bien réjouissez-vous, car `IN` est dans la place ! Cet opérateur vous permet de faire des recherches parmi une liste de valeurs. Parfait pour nous donc, qui voulons rechercher les animaux correspondant à une liste de noms. Voici la manière d'utiliser `IN` :


```sql
SELECT * 
FROM Animal 
WHERE nom IN ('Moka', 'Bilba', 'Tortilla', 'Balou', 'Dana', 'Redbul', 'Gingko');
```

C'est quand même plus agréable à écrire ! :soleil: