Il est bien utile de pouvoir sauvegarder facilement sa base de données, et très important de la sauvegarder régulièrement. Une mauvaise manipulation (ou un méchant pirate  :pirate:  s'il s'agit d'un site web) et toutes les données peuvent disparaître. MySQL dispose donc d'un outil spécialement dédié à la sauvegarde des données sous forme de fichiers texte : `mysqldump`.

Cette fonction de sauvegarde s'utilise à partir de la console. Vous devez donc être déconnectés de MySQL pour la lancer. Si c'est votre cas, tapez simplement `exit`

Vous êtes maintenant dans la console Windows (ou Mac, ou Linux).
La manière classique de faire une sauvegarde d'une base de données est de taper la commande suivante :


```console
mysqldump -u user -p --opt nom_de_la_base > sauvegarde.sql
```

Décortiquons cette commande.


- `mysqldump` : il s'agit du client permettant de sauvegarder les bases. Rien de spécial à signaler.
- `--opt` : c'est une option de `mysqldump` qui lance la commande avec une série de paramètres qui font que la commande s'effectue très rapidement.
- `nom_de_la_base` : vous l'avez sans doute deviné, c'est ici qu'il faut indiquer le nom de la base qu'on veut sauvegarder.
- `> sauvegarde.sql` : le signe ||>|| indique que l'on va donner la destination de ce qui va être généré par la commande : `sauvegarde.sql`. Il s'agit du nom du fichier qui contiendra la sauvegarde de notre base. Vous pouvez bien sûr l'appeler comme bon vous semble.


Lancez la commande suivante pour sauvegarder _elevage_ dans votre dossier courant (c'est-à-dire le dossier dans lequel vous étiez au moment de la connexion) :


```console
mysqldump -u sdz -p --opt elevage > elevage_sauvegarde.sql
```

Puis, allez voir dans le dossier. Vous devriez y trouver un fichier elevage_sauvegarde.sql. Ouvrez-le avec un éditeur de texte.
Vous pouvez voir nombre de commandes SQL qui servent à la création des tables de la base de données, ainsi qu'à l'insertion des données. S'ajoutent à cela quelques commandes qui vont sélectionner le bon encodage, etc.


[[information]]
| Vous pouvez bien entendu sauver votre fichier dans un autre dossier que celui où vous êtes au moment de lancer la commande. Il suffit pour cela de préciser le chemin vers le dossier désiré. Ex : `C:\"Mes Documents"\mysql\sauvegardes\elevage_sauvegarde.sql` au lieu de `elevage_sauvegarde.sql`

La base de données est donc sauvegardée. Notez que la commande pour créer la base elle-même n'est pas sauvée. Donc, si vous effacez votre base par mégarde, il vous faut d'abord recréer la base de données (avec `CREATE DATABASE nom_base`), puis exécuter la commande suivante (dans la console) :


```console
mysql nom_base < chemin_fichier_de_sauvegarde.sql
```

Concrètement, dans notre cas :


```console
mysql elevage < elevage_sauvegarde.sql
```

Ou, directement à partir de MySQL :


```sql
USE nom_base;
source fichier_de_sauvegarde.sql;
```

Donc :


```sql
USE elevage;
source elevage_sauvegarde.sql;
```


[[information]]
| Vous savez maintenant sauvegarder de manière simple vos bases de données. Notez que je ne vous ai donné ici qu'une manière d'utiliser `mysqldump`. En effet, cette commande possède de nombreuses options. Si cela vous intéresse, je vous renvoie à [la documentation de MySQL](http://dev.mysql.com/doc/refman/5.5/en/mysqldump.html) qui sera toujours plus complète que moi.