La modification des données se fait grâce à la commande `UPDATE`, dont la syntaxe est la suivante :


```sql
UPDATE nom_table 
SET col1 = val1 [, col2 = val2, ...] 
[WHERE ...];
```

Par exemple, vous étiez persuadés que ce petit Pataud était un mâle mais, quelques semaines plus tard, vous vous rendez compte de votre erreur. Il vous faut donc modifier son sexe, mais aussi son nom. Voici la requête qui va vous le permettre :


```sql
UPDATE Animal 
SET sexe='F', nom='Pataude' 
WHERE id=21;
```

Vérifiez d'abord chez vous que l'animal portant le numéro d'identification 21 est bien Pataud. J'utilise ici la clé primaire (donc _id_) pour identifier la ligne à modifier, car c'est la seule manière d'être sûr que je ne modifierai que la ligne que je désire. En effet, il est possible que plusieurs animaux aient pour nom "Pataud". Ce n'est a priori pas notre cas, mais prenons tout de suite de bonnes habitudes.


[[attention]]
| Tout comme pour la commande `DELETE`, si vous omettez la clause `WHERE` dans un `UPDATE`, la modification se fera sur toutes les lignes de la table. Soyez prudents !

La requête suivante changerait donc le commentaire de tous les animaux stockés dans la table _Animal_ (ne l'exécutez pas).


```sql
UPDATE Animal 
SET commentaires='modification de toutes les lignes';
```