Exécutez la requête suivante :


```sql
SELECT * FROM Espece
UNION
SELECT * FROM Espece;
```


Non, non, je ne me suis pas trompée, je vous demande bien d'unir deux requêtes qui sont exactement les mêmes.

Résultat :




+--+-----------------+---------------------+------------------------------------------------------------------------+
|id|nom_courant      |nom_latin            |description                                                             |
+==+=================+=====================+========================================================================+
|1 |Chien            |Canis canis          |Bestiole à quatre pattes qui aime les caresses et tire souvent la langue|
+--+-----------------+---------------------+------------------------------------------------------------------------+
|2 |Chat             |Felis silvestris     |Bestiole à quatre pattes qui saute très haut et grimpe aux arbres       |
+--+-----------------+---------------------+------------------------------------------------------------------------+
|3 |Tortue d'Hermann |Testudo hermanni     |Bestiole avec une carapace très dure                                    |
+--+-----------------+---------------------+------------------------------------------------------------------------+
|4 |Perroquet amazone|Alipiopsitta xanthops|Joli oiseau parleur vert et jaune                                       |
+--+-----------------+---------------------+------------------------------------------------------------------------+





Chaque résultat n’apparaît qu'une seule fois. Pour la simple et bonne raison que lorsque vous faites `UNION`, les doublons sont effacés. En fait, `UNION` est équivalent à `UNION DISTINCT`. Si vous voulez conserver les doublons, vous devez utiliser `UNION ALL`.


```sql
SELECT * FROM Espece
UNION ALL
SELECT * FROM Espece;
```





+--+-----------------+---------------------+------------------------------------------------------------------------+
|id|nom_courant      |nom_latin            |description                                                             |
+==+=================+=====================+========================================================================+
|1 |Chien            |Canis canis          |Bestiole à quatre pattes qui aime les caresses et tire souvent la langue|
+--+-----------------+---------------------+------------------------------------------------------------------------+
|2 |Chat             |Felis silvestris     |Bestiole à quatre pattes qui saute très haut et grimpe aux arbres       |
+--+-----------------+---------------------+------------------------------------------------------------------------+
|3 |Tortue d'Hermann |Testudo hermanni     |Bestiole avec une carapace très dure                                    |
+--+-----------------+---------------------+------------------------------------------------------------------------+
|4 |Perroquet amazone|Alipiopsitta xanthops|Joli oiseau parleur vert et jaune                                       |
+--+-----------------+---------------------+------------------------------------------------------------------------+
|1 |Chien            |Canis canis          |Bestiole à quatre pattes qui aime les caresses et tire souvent la langue|
+--+-----------------+---------------------+------------------------------------------------------------------------+
|2 |Chat             |Felis silvestris     |Bestiole à quatre pattes qui saute très haut et grimpe aux arbres       |
+--+-----------------+---------------------+------------------------------------------------------------------------+
|3 |Tortue d'Hermann |Testudo hermanni     |Bestiole avec une carapace très dure                                    |
+--+-----------------+---------------------+------------------------------------------------------------------------+
|4 |Perroquet amazone|Alipiopsitta xanthops|Joli oiseau parleur vert et jaune                                       |
+--+-----------------+---------------------+------------------------------------------------------------------------+






[[information]]
| Il n'est pas possible de mélanger `UNION DISTINCT` et `UNION ALL` dans une même requête. Si vous utilisez les deux, les `UNION ALL` seront considérés comme des `UNION DISTINCT`.