Ce chapitre a été fort théorique jusqu'à maintenant. Donc pour changer un peu, et vous réveiller, je vous propose de passer à la pratique, en utilisant les données de notre base _elevage_. Ces quelques exercices sont faisables en utilisant uniquement les fonctions et opérateurs mathématiques que je vous ai décrits dans ce chapitre.


# On commence par du facile


## 1. Afficher une phrase donnant le prix de l'espèce, pour chaque espèce

Par exemple, afficher "Un chat coûte 100 euros.", ou une autre phrase du genre, et ce pour les cinq espèces enregistrées.


[[secret]]
| ```sql
| SELECT CONCAT('Un(e) ', nom_courant, ' coûte ', prix, ' euros.') AS Solution
| FROM Espece;
| 
| -- OU
| 
| SELECT CONCAT_WS(' ','Un(e)', nom_courant, 'coûte', prix, 'euros.') AS Solution
| FROM Espece;
| ```



## 2. Afficher les chats dont la deuxième lettre du nom est un "a"


[[secret]]
| ```sql
| SELECT Animal.nom, Espece.nom_courant 
| FROM Animal
| INNER JOIN Espece ON Animal.espece_id = Espece.id
| WHERE Espece.nom_courant = 'Chat'
| AND SUBSTRING(nom, 2, 1) = 'a';
| ```


 

# Puis on corse un peu


## 1. Afficher les noms des perroquets en remplaçant les "a" par "@" et les "e" par "3" pour en faire des perroquets Kikoolol


[[secret]]
| ```sql
| SELECT REPLACE(REPLACE(nom, 'a', '@'), 'e', '3') AS Solution
| FROM Animal
| INNER JOIN Espece ON Animal.espece_id = Espece.id
| WHERE Espece.nom_courant LIKE 'Perroquet%';
| ```
| 
| 
| Une petite explication s'impose avant de vous laisser continuer. Comme vous voyez, il est tout à fait possible d'imbriquer plusieurs fonctions. Le tout est de le faire correctement, et pour cela, il faut procéder par étape. Ici, vous voulez faire deux remplacements successifs dans une chaîne de caractères (en l’occurrence, le nom des perroquets). Donc, vous effectuez un premier remplacement, en changeant les "a" par les "@" : `REPLACE(nom, 'a', '@')`. Ensuite, **sur la chaîne résultant de ce premier remplacement**, vous effectuez le second : `REPLACE(REPLACE(nom, 'a', '@'), 'e', '3')`. Logique, non ?




## 2. Afficher les chiens dont le nom a un nombre pair de lettres



[[secret]]
| ```sql
| SELECT nom, nom_courant
| FROM Animal
| INNER JOIN Espece ON Animal.espece_id = Espece.id
| WHERE nom_courant = 'Chien' 
| AND CHAR_LENGTH(nom)%2 = 0;
| 
| -- OU
| 
| SELECT nom, nom_courant
| FROM Animal
| INNER JOIN Espece ON Animal.espece_id = Espece.id
| WHERE nom_courant = 'Chien' 
| AND CHAR_LENGTH(nom) MOD 2 = 0;
| 
| -- OU
| 
| SELECT nom, nom_courant
| FROM Animal
| INNER JOIN Espece ON Animal.espece_id = Espece.id
| WHERE nom_courant = 'Chien' 
| AND MOD(CHAR_LENGTH(nom),2) = 0;
| ```
| 
| 
| Le nombre de lettres, c'était facile, il suffisait d'utiliser `CHAR_LENGTH()`.
| Pour savoir si un nombre est pair, il faut utiliser les modulos : lorsqu'un nombre est pair, le reste d'une division entière de ce nombre par 2 est 0, donc ce nombre **modulo** 2 vaut 0.