# 1. Combien de races avons-nous dans la table _Race_ ?



[[secret]]
| ```sql
| SELECT COUNT(*) 
| FROM Race;
| ```
| 
| 
| Simple échauffement.



# 2. De combien de chiens connaissons-nous le père ?



[[secret]]
| ```sql
| SELECT COUNT(pere_id)
| FROM Animal
| INNER JOIN Espece ON Espece.id = Animal.espece_id
| WHERE Espece.nom_courant = 'Chien';
| ```
| 
| 
| L'astuce ici était de ne pas oublier de donner la colonne _pere_id_ en paramètre à `COUNT()`, pour ne compter que les lignes où _pere_id_ est non `NULL`. Si vous avez fait directement `WHERE espece_id = 1` au lieu d'utiliser une jointure pour sélectionner les chiens, ce n'est pas bien grave.



# 3. Quelle est la date de naissance de notre plus jeune femelle ?


[[secret]]
| ```sql
| SELECT MAX(date_naissance) 
| FROM Animal
| WHERE sexe = 'F';
| ```




# 4. En moyenne, quel est le prix d'un chien ou d'un chat de race, par espèce, et en général ?



[[secret]]
| ```sql
| SELECT nom_courant AS Espece, AVG(Race.prix) AS prix_moyen
| FROM Race
| INNER JOIN Espece ON Race.espece_id = Espece.id
| WHERE Espece.nom_courant IN ('Chat', 'Chien')
| GROUP BY Espece.nom_courant WITH ROLLUP;
| ```
| 
| 
| Ne pas oublier `WITH ROLLUP` pour avoir le résultat général.



# 5. Combien avons-nous de perroquets mâles et femelles, et quels sont leurs noms (en une seule requête bien sûr) ?



[[secret]]
| ```sql
| SELECT sexe, COUNT(*), GROUP_CONCAT(nom SEPARATOR ', ')
| FROM Animal
| INNER JOIN Espece ON Animal.espece_id = Espece.id
| WHERE nom_courant = 'Perroquet amazone'
| GROUP BY sexe;
| ```
| 
| 
| Il suffisait de se souvenir de la méthode `GROUP_CONCAT()` pour pouvoir réaliser simplement cette requête. Peut-être avez-vous groupé sur l'espèce aussi (avec _nom_courant_ ou autre). Ce n'était pas nécessaire puisqu'on avait restreint à une seule espèce avec la clause `WHERE`. Cependant, cela n'influe pas sur le résultat, mais sur la rapidité de la requête.