Voici une dernière fonction ayant trait au format des dates : `STR_TO_DATE(date, format)`. Cette fonction est l'exact contraire de `DATE_FORMAT()` : elle prend une chaîne de caractères représentant une date suivant le format donné, et renvoie la `DATETIME` correspondante.

**Exemples** :


```sql
SELECT STR_TO_DATE('03/04/2011 à 09h17', '%d/%m/%Y à %Hh%i') AS StrDate,
       STR_TO_DATE('15blabla', '%Hblabla') StrTime;
```




+-------------------+--------+
|StrDate            |StrTime |
+===================+========+
|2011-04-03 09:17:00|15:00:00|
+-------------------+--------+





Il est bien sûr possible d'utiliser `GET_FORMAT()` aussi avec `STR_TO_DATE()`.


```sql
SELECT STR_TO_DATE('11.21.2011', GET_FORMAT(DATE, 'USA')) AS date_usa,
       STR_TO_DATE('12.34.45', GET_FORMAT(TIME, 'EUR')) AS heure_eur,
       STR_TO_DATE('20111027133056', GET_FORMAT(TIMESTAMP, 'INTERNAL')) AS date_heure_int;
```




+----------+---------+-------------------+
|date_usa  |heure_eur|date_heure_int     |
+==========+=========+===================+
|2011-11-21|12:34:45 |2011-10-27 13:30:56|
+----------+---------+-------------------+