## 1. Sélectionner tous les animaux nés en juin.


[[secret]]
| ```sql
| SELECT id, date_naissance, nom
| FROM Animal 
| WHERE MONTH(date_naissance) = 6;
| ```




## 2. Sélectionner tous les animaux nés dans les huit premières semaines d'une année.


[[secret]]
| ```sql
| SELECT id, date_naissance, nom
| FROM Animal 
| WHERE WEEKOFYEAR(date_naissance) < 9;
| ```




## 3. Afficher le jour (en chiffres) et le mois de naissance (en toutes lettres) des tortues et des chats nés avant 2007 (en deux colonnes).


[[secret]]
| ```sql
| SELECT DAY(date_naissance), MONTHNAME(date_naissance) 
| FROM Animal 
| INNER JOIN Espece ON Animal.espece_id = Espece.id
| WHERE Espece.nom_courant IN ('Chat', 'Tortue d''Hermann')
| AND YEAR(date_naissance) < 2007;
| ```




## 4. Même chose qu'à la question précédente, mais en une seule colonne.


[[secret]]
| ```sql
| SELECT DATE_FORMAT(date_naissance, '%e %M') 
| FROM Animal 
| INNER JOIN Espece ON Animal.espece_id = Espece.id
| WHERE Espece.nom_courant IN ('Chat', 'Tortue d''Hermann')
| AND YEAR(date_naissance) < 2007;
| ```




## 5. Sélectionner tous les animaux nés en avril, mais pas un 24 avril, triés par heure de naissance décroissante (heure dans le sens commun du terme, donc heure, minutes, secondes) et afficher leur date de naissance suivant le même format que l'exemple ci-dessous.

 **Format** : 8 janvier, à 6h30PM, en l'an 2010 après J.C.



[[secret]]
| ```sql
| SELECT DATE_FORMAT(date_naissance, '%e %M, à %lh%i%p, en l''an %Y après J.C.') AS jolie_date
| FROM Animal
| WHERE MONTH(date_naissance) = 4
| AND DAY(date_naissance) <> 24
| ORDER BY TIME(date_naissance) DESC;
| ```