## 1. Moka était censé naître le 27 février 2008. Calculer le nombre de jours de retard de sa naissance.


[[secret]]
| ```sql
| SELECT DATEDIFF(date_naissance, '2008-02-27')  AS retard
| FROM Animal 
| WHERE nom = 'Moka';
| ```





## 2. Afficher la date à laquelle chaque perroquet (espece_id = 4) fêtera son 25^e^ anniversaire.


[[secret]]
| ```sql
| SELECT DATE(ADDDATE(date_naissance, INTERVAL 25 YEAR)) AS Anniversaire
| FROM Animal 
| WHERE espece_id = 4;
| ```
| 
| 
| On ne demandait que la date (on fête rarement son anniversaire à l'heure pile de sa naissance), d'où l'utilisation de la fonction `DATE()`.




## 3. Sélectionner les animaux nés dans un mois contenant exactement 29 jours.


[[secret]]
| ```sql
| SELECT id, date_naissance, nom
| FROM Animal 
| WHERE DAY(LAST_DAY(date_naissance)) = 29;
| ```




## 4. Après douze semaines, un chaton est sevré (sauf exception bien sûr). Afficher la date à partir de laquelle les chats (espece_id = 2) de l'élevage peuvent être adoptés (qu'il s'agisse d'une date dans le passé ou dans le futur).


[[secret]]
| ```sql
| SELECT id, nom, DATE(DATE_ADD(date_naissance, INTERVAL 12 WEEK)) AS sevrage
| FROM Animal 
| WHERE espece_id = 2;
| ```




## 5. Rouquine, Zira, Bouli et Balou (id 13, 18, 20 et 22 respectivement) font partie de la même portée. Calculer combien de temps, en minutes, Balou est né avant Zira.



[[secret]]
| ```sql
| SELECT TIMESTAMPDIFF(MINUTE, 
| 					(SELECT date_naissance 
| 					FROM Animal 
| 					WHERE nom = 'Balou'), 
| 					(SELECT date_naissance 
| 					FROM Animal 
| 					WHERE nom = 'Zira')) 
| 		AS nb_minutes;
| ```
| 
| 
| Il fallait ici penser aux sous-requêtes, afin d'obtenir les dates de naissance de Balou et Zira pour les utiliser dans la même fonction `TIMESTAMPDIFF()`.