Vous savez déjà que pour terminer une transaction, il faut utiliser les commandes `COMMIT` ou `ROLLBACK`, selon que l'on veut valider les requêtes ou les annuler.

Ça, c'est la manière classique et recommandée. Mais il faut savoir qu'un certain nombre d'autres commandes auront aussi pour effet de clôturer une transaction. Et pas seulement la clôturer, mais également **valider toutes les requêtes** qui ont été faites dans cette transaction. Exactement comme si vous utilisiez `COMMIT`.

Par ailleurs, ces commandes ne peuvent pas être annulées par un `ROLLBACK`.


## Commandes DDL

Toutes les commandes qui créent, modifient, suppriment des objets dans la base de données valident implicitement les transactions. 


[[information]]
| Ces commandes forment ce qu'on appelle les requêtes DDL, pour _Data Definition Langage_.


Cela comprend donc :


- la création et suppression de bases de données : `CREATE DATABASE`, `DROP DATABASE` ;
- la création, modification, suppression de tables : `CREATE TABLE`, `ALTER TABLE`, `RENAME TABLE`, `DROP TABLE` ;
- la création, modification, suppression d'index : `CREATE INDEX`, `DROP INDEX` ;
- la création d'objets comme les procédures stockées, les vues, etc., dont nous parlerons plus tard.


De manière générale, tout ce qui influe sur la **structure de la base de données**, et non sur les données elles-mêmes.


## Utilisateurs

La création, la modification et la suppression d'utilisateurs (voir partie 7) provoquent aussi une validation implicite.


## Transactions et verrous

Je vous ai signalé qu'il n'était pas possible d'imbriquer des transactions, donc d'avoir une transaction à l'intérieur d'une transaction. En fait, la commande `START TRANSACTION` provoque également une validation implicite si elle est exécutée à l'intérieur d'une transaction.
Le fait d'activer le mode _autocommit_ (s'il n'était pas déjà activé) a le même effet.

La création et suppression de **verrous de table** clôturent aussi une transaction en la validant implicitement (voir chapitre suivant).


## Chargements de données

Enfin, le chargement de données avec `LOAD DATA` provoque également une validation implicite.

*[DDL]: Data Definition Langage