Lorsque l'on écrit une série d'instructions, par exemple dans le corps d'une procédure stockée, il est nécessaire d'être capable de structurer ses instructions. Cela va permettre d’instiller de la **logique dans le traitement** : exécuter telles ou telles instructions en fonction des données que l'on possède, répéter une instruction un certain nombre de fois, etc. 

Voici quelques outils indispensables à la structuration des instructions :


- les **variables locales** : qui vont permettre de **stocker et modifier des valeurs** pendant le déroulement d'une procédure ;
- les **conditions** : qui vont permettre d'exécuter certaines instructions seulement **si une certaine condition est remplie** ;
- les **boucles** : qui vont permettre de **répéter une instruction** plusieurs fois.


Ces structures sont bien sûr utilisables dans les procédures stockées, que nous avons vues au chapitre précédent, mais pas uniquement. Elles sont **utilisables dans tout objet définissant une série d'instructions à exécuter**. C'est le cas des **fonctions stockées** (non couvertes par ce cours et qui forment avec les procédures stockées ce qu'on appelle les "routines"), des événements (non couverts), et également des **triggers**, auxquels un chapitre est consacré à la fin de cette partie.