Une fois la vue créée, on peut bien entendu faire plus qu'un simple `SELECT * FROM la_vue;` : on peut tout simplement traiter cette vue comme une table, et donc ajouter des clauses `WHERE`, `GROUP BY`, des fonctions, des jointures et tout ce que l'on veut !

**Exemple 1** : on sélectionne les rats bruns à partir de la vue _V_Animal_details_.


```sql
SELECT id, nom, espece_nom, date_naissance, commentaires, disponible 
FROM V_Animal_details
WHERE espece_nom = 'Rat brun';
```




+--+----+----------+-------------------+------------+----------+
|id|nom |espece_nom|date_naissance     |commentaires|disponible|
+==+====+==========+===================+============+==========+
|69|Baba|Rat brun  |2012-02-13 15:45:00|NULL        |0         |
+--+----+----------+-------------------+------------+----------+
|70|Bibo|Rat brun  |2012-02-13 15:48:00|Agressif    |1         |
+--+----+----------+-------------------+------------+----------+
|72|Momy|Rat brun  |2008-02-01 02:25:00|NULL        |1         |
+--+----+----------+-------------------+------------+----------+
|73|Popi|Rat brun  |2007-03-11 12:45:00|NULL        |1         |
+--+----+----------+-------------------+------------+----------+
|75|Mimi|Rat brun  |2007-03-12 22:03:00|NULL        |0         |
+--+----+----------+-------------------+------------+----------+





**Exemple 2** : on sélectionne le nombre d'animaux par espèce avec la vue _V_Nombre_espece_, en ajoutant une jointure sur la table _Espece_ pour avoir le nom des espèces en plus de leur _id_.


```sql
SELECT V_Nombre_espece.id, Espece.nom_courant, V_Nombre_espece.nb
FROM V_Nombre_espece
INNER JOIN Espece ON Espece.id = V_Nombre_espece.id;
```




+--+-----------------+--+
|id|nom_courant      |nb|
+==+=================+==+
|1 |Chien            |21|
+--+-----------------+--+
|2 |Chat             |20|
+--+-----------------+--+
|3 |Tortue d'Hermann |14|
+--+-----------------+--+
|4 |Perroquet amazone|4 |
+--+-----------------+--+
|5 |Rat brun         |5 |
+--+-----------------+--+





**Exemple 3** : on sélectionne le nombre de chiens qu'on possède pour chaque race, en utilisant un regroupement sur la vue _V_Chien_race_, avec jointure sur _Race_ pour avoir le nom de la race.


```sql
SELECT Race.nom, COUNT(V_Chien_race.id)
FROM Race
INNER JOIN V_Chien_race ON Race.id = V_Chien_race.race_id
GROUP BY Race.nom;
```




+-------------------+----------------------+
|nom                |COUNT(V_Chien_race.id)|
+===================+======================+
|Berger allemand    |8                     |
+-------------------+----------------------+
|Berger blanc suisse|4                     |
+-------------------+----------------------+
|Rottweiller        |1                     |
+-------------------+----------------------+