# Modification


## CREATE OR REPLACE

Comme déjà mentionné, pour modifier une vue, on peut tout simplement ajouter la clause `OR REPLACE` à la requête de création de la vue, et lui donner le nom de la vue à modifier. L'ancienne vue sera alors remplacée.


[[attention]]
| Si le nom de votre vue est incorrect et ne correspond à aucune vue existante, aucune erreur ne sera renvoyée, et vous créerez tout simplement une nouvelle vue.



## ALTER

Il existe aussi la commande `ALTER VIEW`, qui aura le même effet que `CREATE OR REPLACE VIEW` si la vue existe bel et bien. Dans le cas contraire, `ALTER VIEW` générera une erreur.

Syntaxe :


```sql
ALTER VIEW nom_vue [(liste_colonnes)]
AS requete_select
```


**Exemples** : les deux requêtes suivantes ont exactement le même effet : on modifie la vue _V_espece_dollars_ pour mettre à jour le taux de change du dollar.


```sql
CREATE OR REPLACE VIEW V_Espece_dollars
AS SELECT id, nom_courant, nom_latin, description, ROUND(prix*1.30813, 2) AS prix_dollars
FROM Espece;

ALTER VIEW V_Espece_dollars
AS SELECT id, nom_courant, nom_latin, description, ROUND(prix*1.30813, 2) AS prix_dollars
FROM Espece;
```



# Suppression

Pour supprimer une vue, on utilise simplement `DROP VIEW [IF EXISTS] nom_vue;`.

**Exemple** : suppression de _V_Race_.


```sql
DROP VIEW V_Race;
```