[[information]]
| Ce tutoriel a été initialement rédigé sur le Site du Zéro par Taguan sous licence CC BY-NC-SA.

Vous avez de nombreuses données à traiter et vous voulez les organiser correctement, avec un outil adapté ?  
Les bases de données ont été créées pour vous !


Ce tutoriel porte sur **MySQL**, qui est un Système de Gestion de Bases de Données Relationnelles (abrégé SGBDR). C'est-à-dire un logiciel qui permet de gérer des bases de données, et donc de gérer de grosses quantités d'informations. Il utilise pour cela le langage SQL.

Il s'agit d'un des SGBDR les plus connus et les plus utilisés (Wikipédia et Adobe utilisent par exemple MySQL). Et c'est certainement le SGBDR le plus utilisé à ce jour pour réaliser des sites web dynamiques.

MySQL peut donc s'utiliser seul, mais est la plupart du temps combiné à un autre langage de programmation : PHP par exemple pour de nombreux sites web, mais aussi Java, Python, C++, et beaucoup, beaucoup d'autres.


-> [![MySQL avec l'interface PHPMyAdmin](/media/galleries/1255/2e9f5656-6505-441b-b9ea-5317231cd4a8.png)](http://uploads.zestedesavoir.com/files/362001_363000/362872.png)[![MySQL avec une console windows](/media/galleries/1255/62a5fca6-6335-4519-b795-808d81ef6369.png)](http://uploads.zestedesavoir.com/files/362001_363000/362871.png)  
_Différentes façons d'utiliser MySQL_<-



## Quelques exemples d'applications


Vous gérez une boîte de location de matériel audiovisuel, et afin de toujours **savoir où vous en êtes dans votre stock**, vous voudriez un système informatique vous permettant de **gérer les entrées et sorties de matériel**, mais aussi éventuellement **les données de vos clients**. MySQL est une des solutions possibles pour gérer tout ça.

Vous voulez **créer un site web dynamique en HTML/CSS/PHP avec un espace membre, un forum, un système de news ou même un simple livre d'or**. Une base de données vous sera presque indispensable.

Vous créez un super logiciel en Java qui va vous permettre de **gérer vos dépenses** afin de ne plus jamais être à découvert, ou devoir vous affamer pendant trois semaines pour pouvoir payer le cadeau d'anniversaire du petit frère. Vous pouvez utiliser une base de données pour **stocker les dépenses déjà effectuées, les dépenses à venir, les rentrées régulières, ...**

Votre tantine éleveuse d'animaux voudrait un logiciel simple pour gérer ses bestioles, vous savez programmer en python et lui proposez vos services dans l'espoir d'avoir un top cadeau à Noël. Une base de données vous aidera à retenir que Poupouche le Caniche est né le 13 décembre 2007, que Sami le Persan a des poils blancs et que Igor la tortue est le dernier représentant d'une race super rare !


## Points abordés dans ce tutoriel


La conception et l'utilisation de bases de données est un vaste sujet, il a fallu faire des choix sur les thèmes à aborder. Voici les compétences que ce tutoriel vise à vous faire acquérir :



- Création d'une base de données et des tables nécessaires à la gestion des données
- Gestion des relations entre les différentes tables d'une base
- Sélection des données selon de nombreux critères
- Manipulation des données (modification, suppression, calculs divers)
- Utilisation des triggers et des procédures stockées pour automatiser certaines actions
- Utilisation des vues et des tables temporaires
- Gestion des utilisateurs de la base de données
- Et plus encore...

*[SGBDR]: Système de Gestion de Bases de Données Relationnelles